var obj = document.getElementById('drawing');
var ctx = obj.getContext('2d');
var r, n;
var bracing, y_bracing;
var balls = new Array();
var angles;
var activity, v;

function init(){
  r = 15; n = 5;
  bracing = [240,270,300,330,360];
  y_bracing = 210;
  balls = [
  {x: 240, y:360-r},
  {x:270, y:360-r},
  {x:300, y:360-r},
  {x:330, y:360-r},
  {x:360, y:360-r}
];
  angles = [0, 0, 0, 0, 0];
  
  rotateSpeed = Math.PI / 3;
  v = 1; activity = 4;
  a = 0; speed = -Math.PI/3;
  L = 135;
  amplitude = 600;
}

function drawBall(ball){
  ctx.fillStyle = "whyte";
  ctx.beginPath();
  ctx.arc(ball.x,ball.y,r,0,2*Math.PI);
  ctx.fill();
}

function drawStatic(){
  ctx.fillStyle = "white";
  ctx.beginPath();
  ctx.rect(185, 380, 230, 20);
  ctx.fill();
  ctx.strokeStyle="white";  
  ctx.roundRect(185, 210, 230, 190, 20)
  ctx.stroke();
  
  for(let i = 0; i < n; i++){
    drawBall(balls[i]);
    ctx.moveTo(balls[i].x, balls[i].y);
  }
  
}

function drawLines(){
  for(let i = 0; i < n; i++){
    ctx.beginPath();
    ctx.strokeStyle = "white"
    ctx.moveTo(balls[i].x, balls[i].y);
    ctx.lineTo(bracing[i], y_bracing);
    ctx.stroke();
  }
}

var rotateSpeed = Math.PI / 3;
var v = 1;
var a = 0; var speed = -Math.PI/3;
var L = 135;
var amplitude = 600;

function rotate(ind, time){
  let x = balls[ind].x - bracing[ind];
  let y = balls[ind].y - y_bracing;
  
  let dL = Math.sqrt(x*x+y*y);
  
  a = (-amplitude / dL) * Math.sin(angles[ind]);
  speed += a*time;
  angles[ind] += speed*time;
  
  if(v*angles[ind] < 0){
    angles[ind] = 0;
    activity = (activity + 4) % 8; v *= -1;
    a = rotateSpeed*v; speed = a;
  }
  
  balls[ind].x=L*Math.sin(angles[ind]) + bracing[ind];
  balls[ind].y = L*Math.cos(angles[ind]) + y_bracing;

  return activity;
}

function clear(){
  ctx.fillStyle = "#2c2c2c";
  ctx.fillRect(0,0,ctx.canvas.width, ctx.canvas.height);
}

function stopAnimCanv(){
  cancelAnimationFrame(Idint);
}

function startAnimCanv(){
  cancelAnimationFrame(Idint);
  startTime = Date.now();
  Idint = requestAnimationFrame(play);
}

function resetAnimCanv(){
  stopAnimCanv();
  init();
  startAnimCanv();
}

function play(){
  clear();
  var endTime = Date.now();
  time = (endTime - startTime) / 800;
  
  activity = rotate(activity, time);
  
  drawStatic();
  drawLines();
  Idint = requestAnimationFrame(play);
  startTime = endTime;
}

init();
startTime = Date.now();
Idint = requestAnimationFrame(play);